function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);
  return css;
}

import React__default, { createRef, createElement, Component, Fragment } from 'react';
import ReactDOM from 'react-dom';
import { inject, observer, Provider } from 'mobx-react';
import { Circle, Popup, Polygon, Polyline, Map, ZoomControl, ImageOverlay } from 'react-leaflet';
import { CRS } from 'leaflet';
import { autorun, computed, observable, action } from 'mobx';
import classNames from 'classnames';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

___$insertStyle("@import '../../../../node_modules/leaflet/dist/leaflet.css';\n.leaflet-container {\n  height: 100%;\n  background-color: var(--wf-background);\n}\n\n.leaflet-control-container {\n  font-size: var(--wf-font-size);\n}\n.leaflet-control-container .leaflet-left {\n  left: 2em;\n}\n.leaflet-control-container .leaflet-bottom {\n  bottom: 12em;\n}\n.leaflet-control-container .leaflet-bar {\n  border: 2px solid rgba(255, 255, 255, 0.5);\n  box-shadow: none;\n}\n.leaflet-control-container .leaflet-left .leaflet-control {\n  margin-left: 0;\n}\n.leaflet-control-container .leaflet-bottom .leaflet-control {\n  margin-bottom: 0;\n}\n.leaflet-control-container .leaflet-bar a,\n.leaflet-control-container .leaflet-bar a:hover {\n  width: 2em;\n  height: 2em;\n  line-height: 2em;\n  border-bottom: 2px solid rgba(255, 255, 255, 0.5);\n  background-clip: padding-box;\n  background-color: #154071;\n  color: var(--wf-text-color);\n}\n.leaflet-control-container .leaflet-bar a:first-child,\n.leaflet-control-container .leaflet-bar a:hover:first-child {\n  border-top-left-radius: 3px;\n  border-top-right-radius: 3px;\n}\n.leaflet-control-container .leaflet-bar a:last-child,\n.leaflet-control-container .leaflet-bar a:hover:last-child {\n  border-bottom-left-radius: 3px;\n  border-bottom-right-radius: 3px;\n  border-bottom: none;\n}\n.leaflet-control-container .leaflet-bar a.leaflet-disabled {\n  color: rgba(255, 255, 255, 0.5);\n}\n.leaflet-control-container .leaflet-control-zoom-in,\n.leaflet-control-container .leaflet-control-zoom-out {\n  font: 300 2em var(--wf-font-family);\n}");

var CurrentPoint = (function (_super) {
    __extends(CurrentPoint, _super);
    function CurrentPoint() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CurrentPoint.prototype.render = function () {
        var _a, _b;
        var mapStore = this.props.mapStore;
        var currentPoint = (_a = mapStore) === null || _a === void 0 ? void 0 : _a.currentPoint;
        return (React__default.createElement(React__default.Fragment, null, currentPoint.location.floor === ((_b = mapStore) === null || _b === void 0 ? void 0 : _b.activeLevel) &&
            React__default.createElement(React__default.Fragment, null,
                React__default.createElement(Circle, { center: currentPoint.location.positions, radius: 30, color: "transparent" },
                    React__default.createElement(Popup, null,
                        React__default.createElement("div", null,
                            React__default.createElement("h3", null, "You are here!")))))));
    };
    CurrentPoint = __decorate([
        inject(function (store) { return ({
            mapStore: store.rootStore.mapStore,
        }); }),
        observer
    ], CurrentPoint);
    return CurrentPoint;
}(React__default.Component));

___$insertStyle(".fw-popup {\n  font-family: var(--wf-font-family);\n  box-shadow: 0 1em 2.5em 0 rgba(0, 0, 0, 0.1);\n  font-size: var(--wf-font-size);\n}\n.fw-popup .leaflet-popup-content {\n  min-width: 13em;\n  max-width: 15em;\n}\n.fw-popup p {\n  margin: 0;\n}\n.fw-popup .leaflet-popup-content-wrapper {\n  background-color: #ffffff;\n  border-radius: 0.25em;\n  color: var(--wf-panel-background);\n}\n.fw-popup .title {\n  font-size: 0.8em;\n  font-weight: bold;\n  line-height: 1em;\n}\n.fw-popup .description {\n  font-size: 1.5em;\n  line-height: 1em;\n}\n.fw-popup .equipment {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  justify-content: flex-start;\n}\n.fw-popup .equipment .fw-equipment-type {\n  width: 1em;\n  height: 0.8em;\n  margin: 0.5em 1em 0.5em 0;\n  mask-size: contain;\n  background-color: black;\n  opacity: 0.35;\n}\n.fw-popup .direction {\n  margin: 0 0.2em;\n  padding: 0.2em 0;\n  text-align: center;\n  border-radius: 2em;\n  background-color: var(--wf-active-color);\n  color: var(--wf-text-color);\n  font-size: 1.4em;\n}");

var PoiPopup = (function (_super) {
    __extends(PoiPopup, _super);
    function PoiPopup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getDirection = function () {
            var _a;
            var _b = _this.props, closePopup = _b.closePopup, poi = _b.poi, routeStore = _b.routeStore;
            (_a = routeStore) === null || _a === void 0 ? void 0 : _a.setFinishPoint(poi);
            closePopup();
        };
        return _this;
    }
    PoiPopup.prototype.render = function () {
        var poi = this.props.poi;
        var equipment = poi.equipment.map(function (item, index) { return (React__default.createElement("span", { className: classNames('fw-equipment-type', "fw-" + item + "-icon"), key: index })); });
        return (React__default.createElement(Popup, { className: "fw-popup" },
            React__default.createElement("p", { className: "title" }, poi.title),
            React__default.createElement("p", { className: "description" }, poi.description),
            React__default.createElement("p", { className: "equipment" }, equipment),
            React__default.createElement("p", { className: "direction", onClick: this.getDirection }, "Get directions")));
    };
    PoiPopup = __decorate([
        inject(function (store) { return ({
            routeStore: store.rootStore.mapStore.routeStore,
        }); }),
        observer
    ], PoiPopup);
    return PoiPopup;
}(React__default.Component));

var PoiContainer = (function (_super) {
    __extends(PoiContainer, _super);
    function PoiContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.setActive = function () {
            var _a;
            var _b = _this.props, poi = _b.poi, mapStore = _b.mapStore;
            (_a = mapStore) === null || _a === void 0 ? void 0 : _a.setActivePoiId(poi.id);
        };
        _this.closePopup = function () {
            _this.ref.current.leafletElement.closePopup();
        };
        _this.ref = createRef();
        return _this;
    }
    PoiContainer.prototype.componentDidMount = function () {
        var _this = this;
        this.disposer = autorun(function () {
            var _a, _b, _c;
            var _d = _this.props, poi = _d.poi, mapStore = _d.mapStore, routeStore = _d.routeStore;
            ((_a = mapStore) === null || _a === void 0 ? void 0 : _a.activePoiId) === poi.id && !((_b = routeStore) === null || _b === void 0 ? void 0 : _b.pathDetails) && _this.ref.current.leafletElement.openPopup();
            ((_c = mapStore) === null || _c === void 0 ? void 0 : _c.activePoiId) !== poi.id && _this.ref.current.leafletElement.closePopup();
        });
    };
    Object.defineProperty(PoiContainer.prototype, "isSelected", {
        get: function () {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j;
            var _k = this.props, poi = _k.poi, mapStore = _k.mapStore, routeStore = _k.routeStore;
            var active = (((_a = routeStore) === null || _a === void 0 ? void 0 : _a.pathDetails) &&
                ((_b = mapStore) === null || _b === void 0 ? void 0 : _b.activeLevel) === (((_d = (_c = routeStore) === null || _c === void 0 ? void 0 : _c.paths.finishFloor) === null || _d === void 0 ? void 0 : _d.floor) || ((_f = (_e = routeStore) === null || _e === void 0 ? void 0 : _e.paths.currentFloor) === null || _f === void 0 ? void 0 : _f.floor))) ||
                !((_g = routeStore) === null || _g === void 0 ? void 0 : _g.pathDetails);
            return (((_h = mapStore) === null || _h === void 0 ? void 0 : _h.activePoiId) === poi.id && active) || poi.type === ((_j = mapStore) === null || _j === void 0 ? void 0 : _j.activeType);
        },
        enumerable: true,
        configurable: true
    });
    PoiContainer.prototype.componentWillUnmount = function () {
        this.disposer();
    };
    PoiContainer.prototype.render = function () {
        var poi = this.props.poi;
        var color = this.isSelected ? 'var(--wf-active-color)' : 'transparent';
        return (React__default.createElement(React__default.Fragment, null, poi.location.shapeType === 'polygon' ? (React__default.createElement(Polygon, { positions: poi.location.positions, color: color, onClick: this.setActive, ref: this.ref },
            React__default.createElement(PoiPopup, { poi: poi, closePopup: this.closePopup }))) : (React__default.createElement(Circle, { center: poi.location.positions[0], color: color, onClick: this.setActive, radius: poi.location.radius, ref: this.ref },
            React__default.createElement(PoiPopup, { poi: poi, closePopup: this.closePopup })))));
    };
    __decorate([
        computed
    ], PoiContainer.prototype, "isSelected", null);
    PoiContainer = __decorate([
        inject(function (store) { return ({
            mapStore: store.rootStore.mapStore,
            routeStore: store.rootStore.mapStore.routeStore,
        }); }),
        observer
    ], PoiContainer);
    return PoiContainer;
}(React__default.Component));

___$insertStyle(".fw-theMotionPath,\n.fw-theMotionPathEnds,\n.fw-runner {\n  stroke: var(--wf-active-color);\n}\n\n.fw-theMotionPath {\n  stroke-dasharray: 8;\n}\n\n.fw-theMotionPathEnds {\n  stroke-width: 7px;\n}\n\n.fw-runner {\n  fill: var(--wf-active-color);\n}");

var RouteContainer = (function (_super) {
    __extends(RouteContainer, _super);
    function RouteContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.defaultDurationAnimation = 5;
        _this.speedRunner = 100;
        return _this;
    }
    RouteContainer.prototype.componentDidMount = function () {
        var _a, _b, _c, _d;
        var distance = this.props.routeStore.routePath.distance;
        (_a = document.querySelectorAll('.fw-runner')[0]) === null || _a === void 0 ? void 0 : _a.remove();
        var shape = document.createElementNS('http://www.w3.org/2000/svg', 'circle');
        shape.setAttributeNS(null, 'cx', '0');
        shape.setAttributeNS(null, 'cy', '0');
        shape.setAttributeNS(null, 'r', '5');
        shape.setAttributeNS(null, 'class', 'fw-runner');
        shape.innerHTML = "<animateMotion  class=\"animateRunner\" dur=" + (distance / this.speedRunner || this.defaultDurationAnimation) + " \n       repeatCount=\"indefinite\"><mpath xlink:href=\"#routeId\" /></animateMotion>";
        (_b = document.querySelectorAll('.fw-theMotionPath')[0]) === null || _b === void 0 ? void 0 : _b.setAttribute('id', 'routeId');
        var leafletDOMElement = document.querySelectorAll('.leaflet-interactive')[0] && document.querySelectorAll('.leaflet-interactive')[0];
        var parentNode = (_c = leafletDOMElement) === null || _c === void 0 ? void 0 : _c.parentNode;
        (_d = parentNode) === null || _d === void 0 ? void 0 : _d.insertBefore(shape, leafletDOMElement);
    };
    RouteContainer.prototype.componentDidUpdate = function () {
        var distance = this.props.routeStore.routePath.distance;
        document
            .querySelectorAll('.animateRunner')[0]
            .setAttribute('dur', "" + (distance / this.speedRunner || this.defaultDurationAnimation));
    };
    RouteContainer.prototype.render = function () {
        var positions = this.props.routeStore.routePath.positions;
        return (React__default.createElement(React__default.Fragment, null,
            React__default.createElement(Polyline, { className: "fw-theMotionPath", positions: positions }),
            React__default.createElement(Polyline, { className: "fw-theMotionPathEnds", positions: [positions[0], positions[0]] }),
            React__default.createElement(Polyline, { className: "fw-theMotionPathEnds", positions: [positions[positions.length - 1], positions[positions.length - 1]] })));
    };
    RouteContainer = __decorate([
        inject(function (store) { return ({
            routeStore: store.rootStore.mapStore.routeStore,
        }); }),
        observer
    ], RouteContainer);
    return RouteContainer;
}(React__default.Component));

var MapContainer = (function (_super) {
    __extends(MapContainer, _super);
    function MapContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.scaleMaxBounds = 1.2;
        return _this;
    }
    MapContainer.prototype.render = function () {
        var _a = this.props.mapStore, activeLevel = _a.activeLevel, activeMap = _a.activeMap, zoomStep = _a.zoomStep, minZoom = _a.minZoom, maxZoom = _a.maxZoom;
        var bounds = [
            [0, 0],
            [activeMap.mapHeight, activeMap.mapWidth],
        ];
        var maxBounds = [
            [-100, -100],
            [bounds[1][0] * this.scaleMaxBounds, bounds[1][1] * this.scaleMaxBounds],
        ];
        var centerPosition = [activeMap.mapHeight / 2, activeMap.mapWidth / 2];
        var isDisplayedRoute = !!this.props.routeStore.routePath.distance;
        return (React__default.createElement(Map, { attributionControl: false, center: centerPosition, crs: CRS.Simple, key: activeLevel, zoomControl: false, zoomSnap: zoomStep, minZoom: minZoom, maxZoom: maxZoom, bounds: bounds, boundsOptions: { padding: [0, 0] }, maxBounds: maxBounds },
            React__default.createElement(ZoomControl, { position: "bottomleft" }),
            React__default.createElement(ImageOverlay, { url: activeMap.mapUrl, bounds: bounds }),
            activeMap.POIs.map(function (item) { return (React__default.createElement(PoiContainer, { poi: item, key: item.id })); }),
            React__default.createElement(CurrentPoint, null),
            isDisplayedRoute && React__default.createElement(RouteContainer, null)));
    };
    MapContainer = __decorate([
        inject(function (store) { return ({
            mapStore: store.rootStore.mapStore,
            routeStore: store.rootStore.mapStore.routeStore,
        }); }),
        observer
    ], MapContainer);
    return MapContainer;
}(React__default.Component));

var LevelControl = (function (_super) {
    __extends(LevelControl, _super);
    function LevelControl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.clickHandler = function (level) {
            var setActiveLevel = _this.props.mapStore.setActiveLevel;
            return function (event) {
                setActiveLevel(level);
                event.preventDefault();
            };
        };
        return _this;
    }
    LevelControl.prototype.render = function () {
        var _this = this;
        var _a = this.props.mapStore, activeLevel = _a.activeLevel, activeType = _a.activeType, levels = _a.levels;
        var _levels = levels.map(function (level) { return (createElement("div", { className: classNames('fw-floors-button', {
                'fw-floors-button--active': activeLevel === level.nameLevel,
            }), key: level.nameLevel, onClick: _this.clickHandler(level.nameLevel) },
            createElement("span", null,
                "0",
                level.nameLevel),
            !!level.totalAmountTypes[activeType] && createElement("p", { className: "notification" }, level.totalAmountTypes[activeType]))); });
        return (createElement("div", { className: "fw-floors-wrapper" },
            createElement("p", { className: "fw-floors-header" }, "Floor"),
            createElement("div", { className: "fw-floors-buttons-wrapper" }, _levels),
            createElement("p", { className: "fw-floors-header" }, "Zoom")));
    };
    LevelControl = __decorate([
        inject(function (store) { return ({
            mapStore: store.rootStore.mapStore,
            themeStore: store.rootStore.themeStore,
        }); }),
        observer
    ], LevelControl);
    return LevelControl;
}(Component));

var RoutePanel = (function (_super) {
    __extends(RoutePanel, _super);
    function RoutePanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.closePanel = function () {
            var resetPaths = _this.props.routeStore.resetPaths;
            var setActivePoiId = _this.props.mapStore.setActivePoiId;
            return function (event) {
                event.preventDefault();
                resetPaths();
                setActivePoiId('');
            };
        };
        _this.setActiveLevel = function (level) {
            var setActiveLevel = _this.props.mapStore.setActiveLevel;
            return function (event) {
                setActiveLevel(level);
                event.preventDefault();
            };
        };
        return _this;
    }
    RoutePanel.prototype.render = function () {
        var _a, _b, _c, _d, _e, _f, _g;
        var pathDetails = this.props.routeStore.pathDetails;
        var result = [];
        for (var key in pathDetails) {
            pathDetails[key] &&
                result.push(createElement("p", { className: "route-item", onClick: this.setActiveLevel((_a = pathDetails[key]) === null || _a === void 0 ? void 0 : _a.floor), key: key },
                    createElement("span", { className: "route-item-level" },
                        "F", (_b = pathDetails[key]) === null || _b === void 0 ? void 0 :
                        _b.floor),
                    createElement("span", { className: classNames('route-icon', "fw-" + ((_c = pathDetails[key]) === null || _c === void 0 ? void 0 : _c.type) + "-icon") }),
                    createElement("span", { className: classNames('route-item-description', key === 'startPoint' && 'start-point') }, (_d = pathDetails[key]) === null || _d === void 0 ? void 0 : _d.title),
                    !!((_e = pathDetails[key]) === null || _e === void 0 ? void 0 : _e.distance) && (createElement("span", { className: "route-item-steps" },
                        createElement("span", { className: classNames('route-icon', "fw-running-person-icon") }),
                        "\u00A0 ",
                        ~~(((_f = pathDetails[key]) === null || _f === void 0 ? void 0 : _f.distance) / (((_g = this.props.mapStore) === null || _g === void 0 ? void 0 : _g.activeMap.mapScale) || 1)),
                        " steps"))));
        }
        return ((!!pathDetails && (createElement(Fragment, null,
            createElement("div", { className: "fw-destination" },
                createElement("span", null, "Destination:"),
                createElement("span", null, pathDetails.finishPoint.title)),
            createElement("div", { className: "fw-route-panel-wrapper" },
                createElement("div", { className: "fw-route-panel-icon" },
                    createElement("span", { className: classNames('route-icon', "fw-" + (pathDetails['exit'] ? 'route3' : 'route2') + "-icon") })),
                createElement("div", { className: "fw-route-description-wrapper" }, result),
                createElement("div", { className: "fw-route-panel-button-close", onClick: this.closePanel() }, "\u2716"))))) || createElement(Fragment, null));
    };
    RoutePanel = __decorate([
        inject(function (store) { return ({
            mapStore: store.rootStore.mapStore,
            routeStore: store.rootStore.mapStore.routeStore,
        }); }),
        observer
    ], RoutePanel);
    return RoutePanel;
}(Component));

var SearchPOI = (function (_super) {
    __extends(SearchPOI, _super);
    function SearchPOI() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.openSearchPanel = function () {
            var openSearchPanel = _this.props.mapStore.openSearchPanel;
            return function (event) {
                openSearchPanel();
                event.preventDefault();
            };
        };
        _this.setActiveType = function (type) {
            var setActiveType = _this.props.mapStore.setActiveType;
            return function (event) {
                setActiveType(type);
                event.preventDefault();
            };
        };
        return _this;
    }
    SearchPOI.prototype.render = function () {
        var _this = this;
        var _a = this.props.mapStore, activeType = _a.activeType, searchButtons = _a.searchButtons;
        var _searchButtons = searchButtons.map(function (type) { return (createElement("div", { className: classNames('fw-search-button', {
                'fw-search-button--active': activeType === type,
            }), key: type, onClick: type === 'search' ? _this.openSearchPanel() : _this.setActiveType(type) },
            createElement("div", { className: "fw-search-button-box" },
                createElement("span", { className: classNames('fw-search-button-type', "fw-" + type + "-icon") })),
            createElement("span", { className: "fw-search-button-close" }, "\u2716"))); });
        return (createElement("div", { className: "fw-search-wrapper" }, _searchButtons));
    };
    SearchPOI = __decorate([
        inject(function (store) { return ({
            mapStore: store.rootStore.mapStore,
        }); }),
        observer
    ], SearchPOI);
    return SearchPOI;
}(Component));

var SearchPanel = (function (_super) {
    __extends(SearchPanel, _super);
    function SearchPanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { value: '', result: [] };
        _this.minLengthSearchWord = 2;
        _this.handleChange = function (event) {
            var searchInformation = _this.props.mapStore.searchInformation;
            var value = event.target.value;
            var result = searchInformation.filter(function (item) {
                return item.categories.some(function (item) { return value.length > _this.minLengthSearchWord && item.match(value); }) ||
                    (value.length > _this.minLengthSearchWord && item.title.match(value));
            });
            _this.setState({ value: value, result: result });
        };
        _this.closePanel = function () {
            var openSearchPanel = _this.props.mapStore.openSearchPanel;
            return function (event) {
                openSearchPanel();
                event.preventDefault();
                _this.setState({ value: '', result: [] });
            };
        };
        _this.setActivePoiId = function (id, level) {
            var _a = _this.props.mapStore, openSearchPanel = _a.openSearchPanel, setActivePoiId = _a.setActivePoiId, routeStore = _a.routeStore;
            return function (event) {
                routeStore.resetPaths();
                setActivePoiId(id, level);
                openSearchPanel();
                event.preventDefault();
                _this.setState({ value: '', result: [] });
            };
        };
        return _this;
    }
    SearchPanel.prototype.render = function () {
        var _this = this;
        var isOpenSearchPanel = this.props.mapStore.isOpenSearchPanel;
        var result = this.state.result.map(function (item, index) { return (createElement("div", { className: "list-item", onClick: _this.setActivePoiId(item.id, item.floor), key: index },
            createElement("div", { className: "description" },
                createElement("span", { className: "title" }, item.title),
                createElement("span", { className: "subtitle" }, item.categories.join(', '))),
            createElement("div", { className: "location" },
                "Floor ",
                item.floor))); });
        return (isOpenSearchPanel && (createElement("div", { className: "fw-search-panel-wrapper" },
            createElement("div", { className: "fw-search-panel-button-close" },
                createElement("span", { onClick: this.closePanel() }, "\u2716")),
            createElement("div", { className: "search-input" },
                createElement("div", { className: "prefix" },
                    createElement("span", { className: "fw-search-icon" })),
                createElement("input", { type: "text", value: this.state.value, onChange: this.handleChange, placeholder: "Search", autoFocus: true })),
            createElement("div", { className: "fw-search-panel-result" }, result))));
    };
    SearchPanel = __decorate([
        inject(function (store) { return ({
            mapStore: store.rootStore.mapStore,
        }); }),
        observer
    ], SearchPanel);
    return SearchPanel;
}(Component));

___$insertStyle(".fw-floors-wrapper {\n  display: flex;\n  flex-direction: column;\n  position: absolute;\n  bottom: 21em;\n  left: 2em;\n  align-items: center;\n  justify-content: center;\n  z-index: 1000;\n}\n\n.fw-floors-header {\n  color: var(--wf-text-color);\n  font-size: 1.33em;\n  line-height: 0;\n  padding-top: 1em;\n}\n\n.fw-floors-buttons-wrapper {\n  display: flex;\n  flex-direction: column;\n  border-radius: 5px;\n  border: 2px solid rgba(255, 255, 255, 0.5);\n  color: var(--wf-text-color);\n}\n.fw-floors-buttons-wrapper .fw-floors-button {\n  position: relative;\n  width: 2em;\n  height: 2em;\n  font-size: 2em;\n  line-height: 2em;\n  border-bottom: 2px solid rgba(255, 255, 255, 0.5);\n  background-clip: padding-box;\n  background-color: var(--wf-panel-background);\n  cursor: pointer;\n}\n.fw-floors-buttons-wrapper .fw-floors-button span {\n  opacity: 0.5;\n}\n.fw-floors-buttons-wrapper .fw-floors-button--active {\n  background-color: var(--wf-active-color);\n  font-weight: bold;\n}\n.fw-floors-buttons-wrapper .fw-floors-button--active span {\n  opacity: 1;\n}\n.fw-floors-buttons-wrapper .fw-floors-button:first-child {\n  border-radius: 3px 3px 0 0;\n}\n.fw-floors-buttons-wrapper .fw-floors-button:last-child {\n  border-bottom: none;\n  border-radius: 0 0 3px 3px;\n}\n.fw-floors-buttons-wrapper .fw-floors-button .notification {\n  position: absolute;\n  top: -1.3em;\n  right: -0.4em;\n  display: flex;\n  width: 1.5em;\n  height: 1.5em;\n  align-items: center;\n  justify-content: center;\n  color: var(--wf-text-color);\n  background-color: #ff5d5d;\n  border-radius: 50%;\n  font-size: 0.45em;\n  font-weight: 300;\n  line-height: 0.5em;\n  animation: opacity 0.2s ease-in-out;\n}\n@keyframes opacity {\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n}\n\n.fw-search-wrapper {\n  position: absolute;\n  display: flex;\n  flex-direction: row;\n  width: 22em;\n  height: 5.5em;\n  padding: 1em;\n  bottom: 2em;\n  left: 50%;\n  margin-left: -11em;\n  align-items: center;\n  justify-content: center;\n  z-index: 1000;\n  border-radius: 5.5em;\n  box-sizing: border-box;\n  background: var(--wf-panel-background);\n}\n\n.fw-search-button {\n  display: flex;\n  position: relative;\n  align-items: center;\n  justify-content: center;\n  margin: 0 1em;\n  cursor: pointer;\n}\n.fw-search-button .fw-search-button-box {\n  display: flex;\n  position: absolute;\n  width: 3em;\n  height: 3em;\n  align-items: center;\n  justify-content: center;\n  border-radius: 50%;\n  transition: 0.5s ease-out;\n}\n.fw-search-button .fw-search-button-box .fw-search-button-type {\n  display: flex;\n  width: 1.5em;\n  height: 1.5em;\n  padding: 0.5em;\n  margin: 0.5em;\n  background-color: white;\n  mask-size: contain;\n  box-sizing: border-box;\n}\n.fw-search-button .fw-search-button-close {\n  display: flex;\n  width: 1em;\n  height: 1em;\n  padding: 0.5em;\n  align-items: center;\n  justify-content: center;\n  color: var(--wf-active-color);\n  opacity: 0;\n  transition: 0.2s ease-out;\n}\n\n.fw-search-button--active .fw-search-button-box .fw-search-button-type {\n  background-color: var(--wf-panel-background);\n}\n\n.fw-search-button--active .fw-search-button-box {\n  transform: translateY(-2.5em);\n  background-color: white;\n}\n\n.fw-search-button--active .fw-search-button-close {\n  opacity: 1;\n}\n\n.fw-search-panel-wrapper {\n  position: absolute;\n  display: flex;\n  flex-direction: column;\n  width: calc(100% - 2em);\n  height: calc(100% - 2em);\n  margin: 1em;\n  padding: 1em;\n  box-sizing: border-box;\n  border-radius: 0.5em;\n  background-color: var(--wf-panel-background);\n  z-index: 3000;\n}\n.fw-search-panel-wrapper .search-input {\n  display: flex;\n  flex-direction: row;\n  min-height: 4em;\n  margin: 1em;\n  padding: 0 0.5em;\n  border-radius: 0.7em;\n  border: 1px solid rgba(255, 255, 255, 0.5);\n}\n.fw-search-panel-wrapper .search-input .prefix {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n.fw-search-panel-wrapper .search-input .fw-search-icon {\n  width: 1.5em;\n  height: 1.5em;\n  padding-left: 1em;\n  mask-size: contain;\n  background-color: var(--wf-text-color);\n  opacity: 0.5;\n}\n.fw-search-panel-wrapper .search-input input {\n  display: block;\n  width: 100%;\n  color: var(--wf-text-color);\n  background-color: inherit;\n  border: none;\n  outline: none;\n  font-family: inherit;\n  font-size: 1.9em;\n}\n.fw-search-panel-wrapper .search-input input::placeholder {\n  color: var(--wf-text-color);\n  opacity: 50%;\n}\n.fw-search-panel-wrapper .fw-search-panel-button-close {\n  color: var(--wf-active-color);\n  font-size: 1em;\n  text-align: end;\n}\n.fw-search-panel-wrapper .fw-search-panel-result {\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n  justify-content: flex-start;\n  height: 100%;\n  margin: 0.5em 0 0.5em 0.5em;\n  font-size: 1.9em;\n  line-height: 1;\n  color: var(--wf-text-color);\n  overflow-y: auto;\n}\n.fw-search-panel-wrapper .fw-search-panel-result .list-item {\n  display: flex;\n  flex-direction: row;\n  align-items: flex-start;\n  justify-content: space-between;\n  width: 100%;\n  margin-bottom: 0.7em;\n}\n.fw-search-panel-wrapper .fw-search-panel-result .list-item .description {\n  display: flex;\n  flex-direction: column;\n  align-items: flex-start;\n  justify-content: flex-start;\n}\n.fw-search-panel-wrapper .fw-search-panel-result .list-item .subtitle {\n  margin-top: 0.5em;\n  text-align: left;\n  font-size: 0.8em;\n  opacity: 0.5;\n}\n.fw-search-panel-wrapper .fw-search-panel-result .list-item .location {\n  display: flex;\n  align-self: center;\n  justify-content: flex-end;\n  min-width: 20%;\n  margin-right: 0.5em;\n}\n\n.fw-destination {\n  position: absolute;\n  display: flex;\n  flex-direction: column;\n  margin: 1em;\n  padding-left: 2em;\n  z-index: 2000;\n  text-align: start;\n  font-size: 1.9em;\n  color: var(--wf-text-color);\n}\n.fw-destination :last-child {\n  font-weight: 900;\n  color: var(--wf-active-color);\n}\n\n.fw-route-panel-wrapper {\n  position: absolute;\n  display: flex;\n  flex-direction: row;\n  width: calc(100% - 4em);\n  top: 5em;\n  padding: 0.5em;\n  margin: 2em;\n  border-radius: 0.5em;\n  box-sizing: border-box;\n  background-color: var(--wf-panel-background);\n  opacity: 0.93;\n  z-index: 2000;\n}\n.fw-route-panel-wrapper .fw-route-description-wrapper {\n  flex-grow: 1;\n}\n.fw-route-panel-wrapper .fw-route-panel-icon {\n  width: 1em;\n  padding: 1.5em 0;\n}\n.fw-route-panel-wrapper .fw-route-panel-icon .fw-route2-icon,\n.fw-route-panel-wrapper .fw-route-panel-icon .fw-route3-icon {\n  display: flex;\n  height: 100%;\n  background-color: var(--wf-active-color);\n}\n.fw-route-panel-wrapper .route-item {\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  justify-content: flex-start;\n}\n.fw-route-panel-wrapper .route-item-level {\n  padding: 0 1em;\n  font-size: 0.7em;\n  color: var(--wf-active-color);\n}\n.fw-route-panel-wrapper span.route-icon {\n  width: 1.5em;\n  height: 1.5em;\n  padding: 0 0.5em;\n  mask-size: contain;\n  background-color: var(--wf-text-color);\n}\n.fw-route-panel-wrapper .route-item-description,\n.fw-route-panel-wrapper .route-item-steps {\n  padding: 0 0.5em;\n  font-size: 1em;\n  color: var(--wf-text-color);\n}\n.fw-route-panel-wrapper .start-point {\n  color: var(--wf-active-color);\n}\n.fw-route-panel-wrapper .route-item-steps {\n  color: var(--wf-text-color);\n  opacity: 0.48;\n}\n.fw-route-panel-wrapper .fw-route-panel-button-close {\n  color: var(--wf-active-color);\n}");

var Navigation = (function (_super) {
    __extends(Navigation, _super);
    function Navigation() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Navigation.prototype.render = function () {
        return (createElement(Fragment, null,
            createElement(LevelControl, null),
            createElement(SearchPanel, null),
            createElement(SearchPOI, null),
            createElement(RoutePanel, null)));
    };
    return Navigation;
}(Component));

function convertCoords(mapHeight, coord) {
    return [mapHeight - coord[1], +coord[0]];
}
function getDistance(node1, node2) {
    return Math.sqrt(Math.pow(node1[0] - node2[0], 2) + Math.pow(node1[1] - node2[1], 2));
}

var POI = (function () {
    function POI(poi) {
        this.id = poi.id;
        this.title = poi.title;
        this.description = poi.description;
        this.categories = poi.categories || [];
        this.location = poi.location;
        this.equipment = poi.equipment || [];
        this.type = poi.type || "room";
        this.logo = poi.logo || "";
        this.workingHours = poi.workingHours || [];
        this.contact = poi.contact || {};
        this.media = poi.media || [];
    }
    return POI;
}());

var CurrentPoint$1 = (function (_super) {
    __extends(CurrentPoint, _super);
    function CurrentPoint(currentPoint, maps) {
        var _this = _super.call(this, currentPoint) || this;
        _this.categories = ['terminal', 'search', 'find way'];
        _this.type = 'terminal';
        var size = currentPoint.location.size || {
            width: 100,
            height: 100,
        };
        _this.location.positions = currentPoint.location.positions.map(function (point) {
            return convertCoords(maps[currentPoint.location.floor - 1].mapHeight, point);
        })[0];
        _this.location.bounds = _this.getBounds(_this.location.positions, size);
        return _this;
    }
    CurrentPoint.prototype.getBounds = function (positions, size) {
        var width = size.width, height = size.height;
        return [[positions[0] - width / 2, positions[1] - height / 2], [positions[0] + width / 2, positions[1] + height / 2]];
    };
    return CurrentPoint;
}(POI));

var Graph = (function () {
    function Graph(map) {
        this.initNodes(map);
        this.initGraph(map);
    }
    Graph.prototype.initNodes = function (map) {
        var _this = this;
        this.nodes = {};
        map.routeData.nodes.forEach(function (node) {
            var coords = convertCoords(map.mapHeight, node.coords);
            _this.nodes[node.id] = { coords: coords };
        });
        this.nearestExitNodeId = map.routeData.nearestExit.id;
    };
    Graph.prototype.initGraph = function (map) {
        var _this = this;
        this.graph = {};
        var paths = this.getPaths(map);
        paths.forEach(function (path) {
            var start = path.start, finish = path.finish, distance = path.distance;
            !_this.graph[start] && (_this.graph[start] = {});
            _this.graph[start][finish] = distance;
            !_this.graph[finish] && (_this.graph[finish] = {});
            _this.graph[finish][start] = distance;
        });
    };
    Graph.prototype.getPaths = function (map) {
        var _a = map.routeData, nodes = _a.nodes, edges = _a.edges;
        return edges.map(function (edge) {
            var node1 = edge.node1, node2 = edge.node2;
            var start = nodes.filter(function (node) {
                return JSON.stringify(node.coords) === JSON.stringify(node1);
            })[0].id;
            var finish = nodes.filter(function (node) {
                return JSON.stringify(node.coords) === JSON.stringify(node2);
            })[0].id;
            var distance = getDistance(node1, node2);
            return { start: start, finish: finish, distance: distance };
        });
    };
    return Graph;
}());

var RouteStore = (function () {
    function RouteStore(mapStore) {
        this.graphs = [];
        this.mapStore = mapStore;
        this.initGraphs();
        this.initPaths();
    }
    Object.defineProperty(RouteStore.prototype, "routePath", {
        get: function () {
            var _a, _b;
            var activeFloor = this.mapStore.activeLevel === ((_a = this.paths.currentFloor) === null || _a === void 0 ? void 0 : _a.floor)
                ? this.paths.currentFloor
                : this.mapStore.activeLevel === this.paths.finishFloor.floor
                    ? this.paths.finishFloor
                    : null;
            if ((_b = activeFloor) === null || _b === void 0 ? void 0 : _b.path) {
                var graph_1 = this.graphs[activeFloor.floor - 1];
                return {
                    positions: activeFloor.path.path.map(function (item) { return graph_1.nodes[item].coords; }),
                    distance: activeFloor.path.distance,
                };
            }
            return {
                positions: [],
                distance: 0,
            };
        },
        enumerable: true,
        configurable: true
    });
    RouteStore.prototype.initGraphs = function () {
        this.graphs = this.mapStore.maps.map(function (map) {
            return new Graph(map);
        });
    };
    RouteStore.prototype.initPaths = function () {
        var currentPoint = this.mapStore.currentPoint;
        var currentFloorGraph = this.graphs[currentPoint.location.floor - 1];
        this.paths = {
            currentFloor: {
                floor: currentPoint.location.floor,
                startPoint: getGraphNodeNameById(currentPoint.id),
                finishPoint: getGraphNodeNameById(currentFloorGraph.nearestExitNodeId),
                path: null,
            },
            finishFloor: {
                floor: null,
                startPoint: null,
                finishPoint: null,
                path: null,
            },
        };
    };
    RouteStore.prototype.setFinishPoint = function (poi) {
        this.initPaths();
        var pointFloor = this.mapStore.activeMap.floor;
        var pointId = poi.id;
        if (pointFloor !== this.mapStore.currentPoint.location.floor) {
            var finishFloorGraph = this.graphs[pointFloor - 1];
            this.paths.finishFloor = {
                floor: pointFloor,
                startPoint: getGraphNodeNameById(finishFloorGraph.nearestExitNodeId),
                finishPoint: getGraphNodeNameById(pointId),
                path: null,
            };
        }
        else {
            this.paths.currentFloor.finishPoint = getGraphNodeNameById(pointId);
        }
        this.setPaths();
        this.setPathDetails(poi);
    };
    RouteStore.prototype.setPaths = function () {
        var _a = this.paths, currentFloor = _a.currentFloor, finishFloor = _a.finishFloor;
        this.paths.currentFloor.path = this.getShortestPath(this.graphs[currentFloor.floor - 1], currentFloor.startPoint, currentFloor.finishPoint);
        if (finishFloor.floor) {
            this.paths.finishFloor.path = this.getShortestPath(this.graphs[finishFloor.floor - 1], finishFloor.startPoint, finishFloor.finishPoint);
        }
    };
    RouteStore.prototype.setPathDetails = function (poi) {
        this.pathDetails = {
            startPoint: {
                title: this.mapStore.currentPoint.title,
                type: 'picker',
                distance: this.paths.currentFloor.path.distance,
                floor: this.paths.currentFloor.floor,
            },
            exit: this.paths.finishFloor.path && {
                title: "Elevator " + this.paths.finishFloor.floor + " floor",
                type: 'elevator',
                distance: this.paths.finishFloor.path.distance,
                floor: this.paths.finishFloor.floor,
            },
            finishPoint: {
                title: poi.title,
                type: 'room',
                floor: this.paths.finishFloor.floor || this.paths.currentFloor.floor,
            },
        };
    };
    RouteStore.prototype.getShortestPath = function (graph, startPoint, finishPoint) {
        if (!graph.nodes[finishPoint]) {
            finishPoint = startPoint;
        }
        var path = [startPoint];
        var solutions = {};
        solutions[startPoint] = [];
        solutions[startPoint].dist = 0;
        while (true) {
            var parent_1 = '';
            var nearest = '';
            var dist = Infinity;
            for (var node in solutions) {
                if (!solutions[node]) {
                    continue;
                }
                var nearestDist = solutions[node].dist;
                var adj = graph.graph[node];
                for (var a in adj) {
                    if (solutions[a]) {
                        continue;
                    }
                    var newDist = adj[a] + nearestDist;
                    if (newDist < dist) {
                        parent_1 = solutions[node];
                        nearest = a;
                        dist = newDist;
                    }
                }
            }
            if (dist === Infinity) {
                break;
            }
            solutions[nearest] = parent_1.concat(nearest);
            solutions[nearest].dist = dist;
        }
        var finish = solutions[finishPoint];
        return { path: path.concat(finish), distance: finish.dist };
    };
    RouteStore.prototype.resetPaths = function () {
        this.pathDetails = null;
        this.initPaths();
    };
    __decorate([
        observable
    ], RouteStore.prototype, "graphs", void 0);
    __decorate([
        observable
    ], RouteStore.prototype, "mapStore", void 0);
    __decorate([
        observable
    ], RouteStore.prototype, "paths", void 0);
    __decorate([
        observable
    ], RouteStore.prototype, "pathDetails", void 0);
    __decorate([
        computed
    ], RouteStore.prototype, "routePath", null);
    __decorate([
        action.bound
    ], RouteStore.prototype, "initGraphs", null);
    __decorate([
        action.bound
    ], RouteStore.prototype, "initPaths", null);
    __decorate([
        action.bound
    ], RouteStore.prototype, "setFinishPoint", null);
    __decorate([
        action.bound
    ], RouteStore.prototype, "setPaths", null);
    __decorate([
        action.bound
    ], RouteStore.prototype, "setPathDetails", null);
    __decorate([
        action.bound
    ], RouteStore.prototype, "resetPaths", null);
    return RouteStore;
}());
function getGraphNodeNameById(pointId) {
    return "D-" + pointId;
}

var WFMap = (function () {
    function WFMap(map) {
        this.floor = map.floor;
        this.mapHeight = map.mapHeight;
        this.mapWidth = map.mapWidth;
        this.mapName = map.mapName;
        this.mapId = map.mapId;
        this.mapScale = map.mapScale;
        this.mapUrl = map.mapUrl;
        this.routeData = map.routeData;
        this.POIs = map.POIs.map(function (poi) {
            return new POI(poi);
        });
    }
    return WFMap;
}());

var MapStore = (function () {
    function MapStore() {
        this.activePoiId = '';
        this.activeType = '';
        this.isOpenSearchPanel = false;
        this.zoomStep = 0.5;
        this.maxZoom = 1.5;
        this.minZoom = -1.5;
        this.searchButtons = ['room', 'terminal', 'wc', 'exit', 'search'];
    }
    Object.defineProperty(MapStore.prototype, "levels", {
        get: function () {
            return this.maps
                .map(function (item) {
                var result = {};
                item.POIs.forEach(function (item) {
                    result[item.type] = result[item.type] + 1 || 1;
                });
                return {
                    nameLevel: item.floor,
                    totalAmountTypes: result,
                };
            })
                .reverse();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MapStore.prototype, "searchInformation", {
        get: function () {
            var result = [];
            this.maps.forEach(function (item) {
                return item.POIs.forEach(function (_item) {
                    return result.push({ categories: _item.categories, floor: item.floor, title: _item.title, id: _item.id });
                });
            });
            return result;
        },
        enumerable: true,
        configurable: true
    });
    MapStore.prototype.setActiveLevel = function (level) {
        this.activeLevel = level;
        this.activeMap = this.maps[this.activeLevel - 1];
    };
    MapStore.prototype.openSearchPanel = function () {
        this.isOpenSearchPanel = !this.isOpenSearchPanel;
    };
    MapStore.prototype.setActivePoiId = function (id, level) {
        level && this.setActiveLevel(level);
        this.activePoiId = id;
    };
    MapStore.prototype.setActiveType = function (type) {
        if (type === this.activeType) {
            this.activeType = '';
        }
        else {
            this.activeType = type;
            this.activePoiId = '';
        }
    };
    MapStore.prototype.createMaps = function (mapData) {
        var maps = mapData.slice();
        return maps.map(function (map) {
            var wfMap = new WFMap(map);
            wfMap.POIs.forEach(function (poi) {
                poi.location.positions = poi.location.positions.map(function (point) {
                    return convertCoords(map.mapHeight, point);
                });
            });
            return wfMap;
        });
    };
    MapStore.prototype.initMapData = function (mapData, currentPoint) {
        this.maps = this.createMaps(mapData);
        this.currentPoint = new CurrentPoint$1(currentPoint, this.maps);
        this.activeLevel = this.currentPoint.location.floor;
        this.activeMap = this.maps[this.activeLevel - 1];
        this.routeStore = new RouteStore(this);
    };
    __decorate([
        observable
    ], MapStore.prototype, "activeLevel", void 0);
    __decorate([
        observable
    ], MapStore.prototype, "activeMap", void 0);
    __decorate([
        observable
    ], MapStore.prototype, "activePoiId", void 0);
    __decorate([
        observable
    ], MapStore.prototype, "activeType", void 0);
    __decorate([
        observable
    ], MapStore.prototype, "currentPoint", void 0);
    __decorate([
        observable
    ], MapStore.prototype, "maps", void 0);
    __decorate([
        observable
    ], MapStore.prototype, "isOpenSearchPanel", void 0);
    __decorate([
        observable
    ], MapStore.prototype, "routeStore", void 0);
    __decorate([
        computed
    ], MapStore.prototype, "levels", null);
    __decorate([
        computed
    ], MapStore.prototype, "searchInformation", null);
    __decorate([
        action.bound
    ], MapStore.prototype, "setActiveLevel", null);
    __decorate([
        action.bound
    ], MapStore.prototype, "openSearchPanel", null);
    __decorate([
        action.bound
    ], MapStore.prototype, "setActivePoiId", null);
    __decorate([
        action.bound
    ], MapStore.prototype, "setActiveType", null);
    __decorate([
        action.bound
    ], MapStore.prototype, "initMapData", null);
    return MapStore;
}());

var ThemeStore = (function () {
    function ThemeStore() {
    }
    ThemeStore.prototype.initThemeData = function (themes) {
        this.themes = themes;
        this.activeTheme = themes.defaultTheme;
    };
    ThemeStore.prototype.setTheme = function (theme) {
        this.activeTheme = this.themes[theme];
    };
    __decorate([
        observable
    ], ThemeStore.prototype, "activeTheme", void 0);
    __decorate([
        observable
    ], ThemeStore.prototype, "themes", void 0);
    __decorate([
        action.bound
    ], ThemeStore.prototype, "initThemeData", null);
    __decorate([
        action.bound
    ], ThemeStore.prototype, "setTheme", null);
    return ThemeStore;
}());

var RootStore = (function () {
    function RootStore() {
    }
    RootStore.prototype.initData = function (maps, currentPoint, themes) {
        this.mapStore = new MapStore();
        this.themeStore = new ThemeStore();
        this.mapStore.initMapData(maps, currentPoint);
        this.themeStore.initThemeData(themes);
    };
    __decorate([
        observable
    ], RootStore.prototype, "mapStore", void 0);
    __decorate([
        observable
    ], RootStore.prototype, "themeStore", void 0);
    __decorate([
        action.bound
    ], RootStore.prototype, "initData", null);
    return RootStore;
}());
var RootStore$1 = new RootStore();

___$insertStyle("@font-face {\n  font-family: \"Klavika\";\n  font-style: normal;\n  font-weight: 400;\n  src: local(\"Klavika\"), url(../../assets/fonts/Klavika.woff2) format(\"woff2\");\n}\n:root {\n  --wf-panel-background: red;\n}\n\n@media (max-width: 4320px) {\n  :root {\n    --wf-font-size: 72px;\n  }\n}\n@media (max-width: 2160px) {\n  :root {\n    --wf-font-size: 36px;\n  }\n}\n@media (max-width: 1080px) {\n  :root {\n    --wf-font-size: 24px;\n  }\n}\n@media (max-width: 768px) {\n  :root {\n    --wf-font-size: 16px;\n  }\n}\n@media (max-width: 576px) {\n  :root {\n    --wf-font-size: 12px;\n  }\n}\n.way-finding-container {\n  height: 100%;\n  box-sizing: border-box;\n  text-align: center;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n  user-select: none;\n  position: relative;\n  font-family: var(--wf-font-family);\n  font-size: var(--wf-font-size);\n}\n.way-finding-container ::-webkit-scrollbar {\n  width: 0.4em;\n  opacity: 0.35;\n}\n.way-finding-container ::-webkit-scrollbar-thumb {\n  border-radius: 0.25em;\n  background: rgba(255, 255, 255, 0.35);\n}\n.way-finding-container .fw-elevator-icon {\n  mask: url(../../assets/images/elevator.svg) center no-repeat;\n}\n.way-finding-container .fw-exit-icon {\n  mask: url(../../assets/images/exit.svg) center no-repeat;\n}\n.way-finding-container .fw-search-icon {\n  mask: url(../../assets/images/search.svg) center no-repeat;\n}\n.way-finding-container .fw-terminal-icon {\n  mask: url(../../assets/images/terminal.svg) center no-repeat;\n}\n.way-finding-container .fw-room-icon {\n  mask: url(../../assets/images/room.svg) center no-repeat;\n}\n.way-finding-container .fw-route2-icon {\n  mask: url(../../assets/images/route2.svg) center no-repeat;\n}\n.way-finding-container .fw-route3-icon {\n  mask: url(../../assets/images/route3.svg) center no-repeat;\n}\n.way-finding-container .fw-running-person-icon {\n  mask: url(../../assets/images/running-person.svg) center no-repeat;\n}\n.way-finding-container .fw-wc-icon {\n  mask: url(../../assets/images/wc.svg) center no-repeat;\n}\n.way-finding-container .fw-fan-icon {\n  mask: url(../../assets/images/fan.svg) center no-repeat;\n}\n.way-finding-container .fw-laptop-icon {\n  mask: url(../../assets/images/laptop.svg) center no-repeat;\n}\n.way-finding-container .fw-phone-icon {\n  mask: url(../../assets/images/phone.svg) center no-repeat;\n}\n.way-finding-container .fw-picker-icon.route-icon {\n  background: url(../../assets/images/picker.svg) center no-repeat;\n  background-size: contain;\n  background-color: transparent;\n}\n.way-finding-container .fw-projector-icon {\n  mask: url(../../assets/images/projector.svg) center no-repeat;\n}\n.way-finding-container .fw-wifi-icon {\n  mask: url(../../assets/images/wifi.svg) center no-repeat;\n}");

var WayFinding = (function (_super) {
    __extends(WayFinding, _super);
    function WayFinding() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WayFinding.prototype.componentDidMount = function () {
        this.updateCSSVariables();
    };
    WayFinding.prototype.componentDidUpdate = function (prevProps) {
        if (this.props.themeData !== prevProps.themeData) {
            this.updateCSSVariables();
        }
    };
    WayFinding.prototype.updateCSSVariables = function () {
        var _this = this;
        Object.keys(this.props.themeData).forEach(function (key) {
            var value = _this.props.themeData[key];
            document.documentElement.style.setProperty(key, value);
        });
    };
    WayFinding.prototype.render = function () {
        RootStore$1.initData(this.props.mapData, this.props.currentPoint, this.props.themeData);
        return (React__default.createElement(Provider, { rootStore: RootStore$1 },
            React__default.createElement("div", { className: "way-finding-container" },
                React__default.createElement(Navigation, null),
                React__default.createElement(MapContainer, null))));
    };
    WayFinding = __decorate([
        observer
    ], WayFinding);
    return WayFinding;
}(React__default.Component));

var arrayX = [
    '451',
    '451',
    '451',
    '451',
    '451',
    '451',
    '451',
    '223',
    '118',
    '5',
    '118',
    '223',
    '422',
    '560',
    '657',
    '654',
    '654',
    '680',
];
var arrayY = [
    '5',
    '158',
    '294',
    '434',
    '567',
    '700',
    '838',
    '884',
    '884',
    '883.8',
    '1086',
    '1103',
    '1103',
    '1103',
    '1103',
    '904',
    '769',
    '434',
];
var arrayWidth = [
    '142',
    '142',
    '142',
    '142',
    '142',
    '142',
    '142',
    '130',
    '100',
    '108',
    '100',
    '194',
    '133',
    '92',
    '148',
    '151',
    '151',
    '125',
];
var arrayHeight = [
    '148',
    '131',
    '135',
    '128',
    '128',
    '133',
    '61',
    '160',
    '160',
    '371',
    '169',
    '152',
    '152',
    '152',
    '152',
    '140',
    '130',
    '129',
];
var arrayIds = [
    'room-1_1_',
    'room-3_1_',
    'room-5_1_',
    'room-8_1_',
    'room-10_1_',
    'room-12_1_',
    'room-14',
    'room-21',
    'room-23',
    'room-25',
    'room-24',
    'room-19',
    'room-26',
    'room-18',
    'room-17',
    'room-16',
    'room-13_1_',
    'room-9_1_',
    'room-2_1_',
];
var poiType;
(function (poiType) {
    poiType["Room"] = "room";
    poiType["Terminal"] = "terminal";
    poiType["WC"] = "wc";
    poiType["Exit"] = "exit";
    poiType["Store"] = "store";
    poiType["Exchange"] = "exchange";
    poiType["Food"] = "food";
    poiType["Parking"] = "parking";
})(poiType || (poiType = {}));
var arrayType = [
    'room',
    'exchange',
    'store',
    'room',
    'food',
    'exchange',
    'store',
    'food',
    'room',
    'exchange',
    'store',
    'food',
    'room',
    'exchange',
    'store',
    'food',
    'room',
    'exchange',
];
var circles = [
    { positions: [[405, 971.72]], r: 30, type: 'exit', shapeType: 'circle', id: 'Stairs_1' },
    { positions: [[731.5, 971.72]], r: 30, type: 'wc', shapeType: 'circle', id: 'Toilet' },
    { positions: [[744, 665.72]], r: 30, type: 'exit', shapeType: 'circle', id: 'Stairs_2' },
];
var polygons = [
    [
        [806, 206],
        [687, 206],
        [687, 167],
        [655, 167],
        [655, 45],
        [664, 45],
        [664, 5],
        [806, 5],
    ],
];
function getXYWH(x, y, w, h) {
    return x.map(function (item, index) {
        return [].concat(item, y[index], w[index], h[index]);
    });
}
function getPointsPosition(arrayXYWH) {
    return arrayXYWH.map(function (item) {
        var x = Number(item[0]);
        var y = Number(item[1]);
        var w = Number(item[2]);
        var h = Number(item[3]);
        return [
            [x, y],
            [x + w, y],
            [x + w, y + h],
            [x, y + h],
        ];
    });
}
var createPoints = function (points) {
    return points.map(function (point, index) {
        return new POI({
            title: 'room ' + index,
            id: point.id || arrayIds[index],
            description: 'the best room ' + index,
            categories: index % 2 === 0 ? ['adidas', 'sport store', 't-shirt', 'sport'] : ['apple', 'apple store', 'phone'],
            equipment: index % 2 === 0 ? ['laptop', 'phone', 'fan', 'wifi'] : ['laptop', 'projector', 'conditioner'],
            location: {
                shapeType: point.shapeType ? point.shapeType : 'polygon',
                positions: point.positions ? point.positions : point,
                radius: point.r ? point.r : null,
            },
            type: point.type ? point.type : arrayType[index],
        });
    });
};
var getPoints = function () {
    var arrayXYWH = getXYWH(arrayX, arrayY, arrayWidth, arrayHeight);
    var polygonsPosition = getPointsPosition(arrayXYWH).concat(polygons);
    return createPoints(polygonsPosition).concat(createPoints(circles));
};
var routeString = "<g id=\"Roud\">\n\t<line id=\"Line-1_5_\" class=\"st39\" x1=\"593\" y1=\"59\" x2=\"624\" y2=\"59\"/>\n\t<line id=\"Line-2_1_\" class=\"st39\" x1=\"624\" y1=\"112\" x2=\"655\" y2=\"112\"/>\n\t<line id=\"Line-3\" class=\"st39\" x1=\"624\" y1=\"59\" x2=\"624\" y2=\"112\"/>\n\t<line id=\"Line-4\" class=\"st39\" x1=\"624\" y1=\"112\" x2=\"624\" y2=\"190\"/>\n\t<line id=\"Line-7\" class=\"st39\" x1=\"624\" y1=\"190\" x2=\"624\" y2=\"324\"/>\n\t<line id=\"Line-9\" class=\"st39\" x1=\"624\" y1=\"324\" x2=\"624\" y2=\"374\"/>\n\t<line id=\"Line-11\" class=\"st39\" x1=\"685\" y1=\"322\" x2=\"685\" y2=\"374\"/>\n\t<line id=\"Line-6\" class=\"st39\" x1=\"624\" y1=\"190\" x2=\"655\" y2=\"190\"/>\n\t<line id=\"Line-5\" class=\"st39\" x1=\"593\" y1=\"190\" x2=\"624\" y2=\"190\"/>\n\t<line id=\"Line-8\" class=\"st39\" x1=\"593\" y1=\"324\" x2=\"624\" y2=\"324\"/>\n\t<line id=\"Line-10\" class=\"st39\" x1=\"624\" y1=\"374\" x2=\"685\" y2=\"374\"/>\n\t<line id=\"Line-14\" class=\"st39\" x1=\"593\" y1=\"495\" x2=\"624\" y2=\"495\"/>\n\t<line id=\"Line-12\" class=\"st39\" x1=\"685\" y1=\"374\" x2=\"725\" y2=\"374\"/>\n\t<line id=\"Line-13\" class=\"st39\" x1=\"624\" y1=\"374\" x2=\"624\" y2=\"495\"/>\n\t<line id=\"Line-15\" class=\"st39\" x1=\"624\" y1=\"495\" x2=\"624\" y2=\"534\"/>\n\t<line id=\"Line-17\" class=\"st39\" x1=\"624\" y1=\"534\" x2=\"624\" y2=\"602\"/>\n\t<line id=\"Line-16\" class=\"st39\" x1=\"624\" y1=\"534\" x2=\"680\" y2=\"534\"/>\n\t<circle id=\"D-room-1_1_\" class=\"st2\" cx=\"593\" cy=\"59\" r=\"0.5\"/>\n\t<circle id=\"D-room-2_1_\" class=\"st2\" cx=\"655\" cy=\"112\" r=\"0.5\"/>\n\t<circle id=\"D-room-3_1_\" class=\"st2\" cx=\"593\" cy=\"190\" r=\"0.5\"/>\n\t<circle id=\"D-room-4_1_\" class=\"st2\" cx=\"655\" cy=\"190\" r=\"0.5\"/>\n\t<circle id=\"D-room-5_1_\" class=\"st2\" cx=\"593\" cy=\"324\" r=\"0.5\"/>\n\t<circle id=\"D-room-6_1_\" class=\"st2\" cx=\"685\" cy=\"322\" r=\"0.5\"/>\n\t<circle id=\"D-room-7_1_\" class=\"st2\" cx=\"725\" cy=\"374\" r=\"0.5\"/>\n\t<circle id=\"D-room-8\" class=\"st2\" cx=\"593\" cy=\"495\" r=\"0.5\"/>\n\t<circle id=\"D-room-9_1_\" class=\"st2\" cx=\"680\" cy=\"534\" r=\"0.5\"/>\n\t<line id=\"Line-18\" class=\"st39\" x1=\"593\" y1=\"602\" x2=\"624\" y2=\"602\"/>\n\t<circle id=\"D-room-10_1_\" class=\"st2\" cx=\"593\" cy=\"602\" r=\"0.5\"/>\n\t<line id=\"Line-19\" class=\"st39\" x1=\"624\" y1=\"602\" x2=\"680\" y2=\"602\"/>\n\t<line id=\"Line-20\" class=\"st39\" x1=\"624\" y1=\"602\" x2=\"624\" y2=\"731\"/>\n\t<circle id=\"D-room-11\" class=\"st2\" cx=\"680\" cy=\"602\" r=\"0.5\"/>\n\t<line id=\"Line-21\" class=\"st39\" x1=\"593\" y1=\"731\" x2=\"624\" y2=\"731\"/>\n\t<line id=\"Line-22\" class=\"st39\" x1=\"624\" y1=\"731\" x2=\"624\" y2=\"831\"/>\n\t<line id=\"Line-23\" class=\"st39\" x1=\"624\" y1=\"831\" x2=\"655\" y2=\"831\"/>\n\t<line id=\"Line-24\" class=\"st39\" x1=\"624\" y1=\"831\" x2=\"624\" y2=\"878\"/>\n\t<line id=\"Line-25\" class=\"st39\" x1=\"593\" y1=\"878\" x2=\"624\" y2=\"878\"/>\n\t<circle id=\"D-room-12\" class=\"st2\" cx=\"593\" cy=\"731\" r=\"0.5\"/>\n\t<circle id=\"D-room-13\" class=\"st2\" cx=\"655\" cy=\"831\" r=\"0.5\"/>\n\t<circle id=\"D-room-14\" class=\"st2\" cx=\"593\" cy=\"878\" r=\"0.5\"/>\n\t<line id=\"Line-26\" class=\"st39\" x1=\"624\" y1=\"878\" x2=\"624\" y2=\"976\"/>\n\t<line id=\"Line-27\" class=\"st39\" x1=\"579\" y1=\"976\" x2=\"624\" y2=\"976\"/>\n\t<line id=\"Line-28\" class=\"st39\" x1=\"624\" y1=\"976\" x2=\"655\" y2=\"976\"/>\n\t<circle id=\"D-room-15\" class=\"st2\" cx=\"579\" cy=\"976\" r=\"0.5\"/>\n\t<circle id=\"D-room-16\" class=\"st2\" cx=\"655\" cy=\"976\" r=\"0.5\"/>\n\t<line id=\"Line-29\" class=\"st39\" x1=\"624\" y1=\"976\" x2=\"624\" y2=\"1074\"/>\n\t<line id=\"Line-30\" class=\"st39\" x1=\"624\" y1=\"1074\" x2=\"730\" y2=\"1074\"/>\n\t<line id=\"Line-31\" class=\"st39\" x1=\"730\" y1=\"1074\" x2=\"730\" y2=\"1103\"/>\n\t<line id=\"Line-33\" class=\"st39\" x1=\"600\" y1=\"1074\" x2=\"600\" y2=\"1103\"/>\n\t<line id=\"Line-31_1_\" class=\"st39\" x1=\"600\" y1=\"1074\" x2=\"624\" y2=\"1074\"/>\n\t<line id=\"Line-34\" class=\"st39\" x1=\"507\" y1=\"1074\" x2=\"600\" y2=\"1074\"/>\n\t<line id=\"Line-36\" class=\"st39\" x1=\"403\" y1=\"1074\" x2=\"403\" y2=\"1103\"/>\n\t<line id=\"Line-35\" class=\"st39\" x1=\"403\" y1=\"1018\" x2=\"403\" y2=\"1074\"/>\n\t<line id=\"Line-37\" class=\"st39\" x1=\"268\" y1=\"1074\" x2=\"403\" y2=\"1074\"/>\n\t<line id=\"Line-38\" class=\"st39\" x1=\"268\" y1=\"1044\" x2=\"268\" y2=\"1074\"/>\n\t<line id=\"Line-41\" class=\"st39\" x1=\"174\" y1=\"1074\" x2=\"268\" y2=\"1074\"/>\n\t<line id=\"Line-42\" class=\"st39\" x1=\"174\" y1=\"1044\" x2=\"174\" y2=\"1074\"/>\n\t<line id=\"Line-43\" class=\"st39\" x1=\"174\" y1=\"1074\" x2=\"174\" y2=\"1086\"/>\n\t<line id=\"Line-44\" class=\"st39\" x1=\"113\" y1=\"1074\" x2=\"174\" y2=\"1074\"/>\n\t<circle id=\"D-room-17\" class=\"st2\" cx=\"730\" cy=\"1103\" r=\"0.5\"/>\n\t<circle id=\"D-room-18\" class=\"st2\" cx=\"600\" cy=\"1103\" r=\"0.5\"/>\n\t<circle id=\"D-room-19\" class=\"st2\" cx=\"403\" cy=\"1103\" r=\"0.5\"/>\n\t<circle id=\"D-room-20\" class=\"st2\" cx=\"403\" cy=\"1018\" r=\"0.5\"/>\n\t<circle id=\"D-room-21\" class=\"st2\" cx=\"268\" cy=\"1044\" r=\"0.5\"/>\n\t<circle id=\"D-room-23\" class=\"st2\" cx=\"174\" cy=\"1044\" r=\"0.5\"/>\n\t<circle id=\"D-room-24\" class=\"st2\" cx=\"174\" cy=\"1086\" r=\"0.5\"/>\n\t<circle id=\"D-room-25\" class=\"st2\" cx=\"113\" cy=\"1074\" r=\"0.5\"/>\n\t<line id=\"Line-46\" class=\"st39\" x1=\"507\" y1=\"1074\" x2=\"507\" y2=\"1103\"/>\n\t<line id=\"Line-45\" class=\"st39\" x1=\"403\" y1=\"1074\" x2=\"507\" y2=\"1074\"/>\n\t<circle id=\"D-room-26\" class=\"st2\" cx=\"507\" cy=\"1103\" r=\"0.5\"/>\n\t<circle id=\"D27\" class=\"st2\" cx=\"624\" cy=\"59\" r=\"0.5\"/>\n\t<circle id=\"D28\" class=\"st2\" cx=\"624\" cy=\"112\" r=\"0.5\"/>\n\t<circle id=\"D29\" class=\"st2\" cx=\"624\" cy=\"190\" r=\"0.5\"/>\n\t<circle id=\"D30\" class=\"st2\" cx=\"624\" cy=\"324\" r=\"0.5\"/>\n\t<circle id=\"D32\" class=\"st2\" cx=\"624\" cy=\"374\" r=\"0.5\"/>\n\t<circle id=\"D33\" class=\"st2\" cx=\"624\" cy=\"495\" r=\"0.5\"/>\n\t<circle id=\"D34\" class=\"st2\" cx=\"624\" cy=\"534\" r=\"0.5\"/>\n\t<circle id=\"D35\" class=\"st2\" cx=\"624\" cy=\"602\" r=\"0.5\"/>\n\t<circle id=\"D36\" class=\"st2\" cx=\"624\" cy=\"731\" r=\"0.5\"/>\n\t<circle id=\"D37\" class=\"st2\" cx=\"624\" cy=\"831\" r=\"0.5\"/>\n\t<circle id=\"D38\" class=\"st2\" cx=\"624\" cy=\"878\" r=\"0.5\"/>\n\t<circle id=\"D39\" class=\"st2\" cx=\"624\" cy=\"976\" r=\"0.5\"/>\n\t<circle id=\"D40\" class=\"st2\" cx=\"624\" cy=\"1074\" r=\"0.5\"/>\n\t<circle id=\"D41\" class=\"st2\" cx=\"730\" cy=\"1074\" r=\"0.5\"/>\n\t<circle id=\"D42\" class=\"st2\" cx=\"600\" cy=\"1074\" r=\"0.5\"/>\n\t<circle id=\"D43\" class=\"st2\" cx=\"507\" cy=\"1074\" r=\"0.5\"/>\n\t<circle id=\"D44\" class=\"st2\" cx=\"403\" cy=\"1074\" r=\"0.5\"/>\n\t<circle id=\"D45\" class=\"st2\" cx=\"268\" cy=\"1074\" r=\"0.5\"/>\n\t<circle id=\"D46\" class=\"st2\" cx=\"174\" cy=\"1074\" r=\"0.5\"/>\n\t<circle id=\"D47\" class=\"st2\" cx=\"685\" cy=\"374\" r=\"0.5\"/>\n</g>\n";
var pointsRE = /circle id="([^"]+)" class="[^"]+" cx="([^"]+)" cy="([^"]+)"/gm;
var linesRE = /line id="([^"]+)" class="[^"]+" x1="([^"]+)" y1="([^"]+)" x2="([^"]+)" y2="([^"]+)"/gm;
function getNodes() {
    return Array.from(routeString.matchAll(pointsRE)).map(function (point) {
        return { id: point[1], coords: [+point[2], +point[3]] };
    });
}
function getEdges() {
    return Array.from(routeString.matchAll(linesRE)).map(function (line) {
        var x1, y1, x2, y2;
        x1 = line[2];
        y1 = line[3];
        x2 = line[4];
        y2 = line[5];
        return { node1: [+x1, +y1], node2: [+x2, +y2] };
    });
}
var data = {
    maps: [
        {
            mapWidth: 810,
            mapHeight: 1260,
            mapName: 'Test Map 1',
            mapId: 'map1',
            mapUrl: 'map_1.svg',
            mapScale: 25,
            floor: 1,
            POIs: getPoints(),
            routeData: {
                nodes: getNodes(),
                edges: getEdges(),
                nearestExit: {
                    id: 'room-6_1_',
                    title: 'elevator',
                    description: 'the elevator',
                    location: {
                        shapeType: 'polygon',
                        positions: [
                            [0, 118],
                            [174, 118],
                            [174, 222],
                            [0, 222],
                        ],
                    },
                },
            },
        },
        {
            mapWidth: 810,
            mapHeight: 1260,
            mapScale: 25,
            mapName: 'Test Map 2',
            mapId: 'map2',
            mapUrl: 'map_1.svg',
            floor: 2,
            POIs: getPoints(),
            routeData: {
                nodes: getNodes(),
                edges: getEdges(),
                nearestExit: {
                    id: 'room-6_1_',
                    title: 'elevator',
                    description: 'the elevator',
                    location: {
                        shapeType: 'polygon',
                        positions: [
                            [0, 118],
                            [174, 118],
                            [174, 222],
                            [0, 222],
                        ],
                    },
                },
            },
        },
        {
            mapWidth: 810,
            mapHeight: 1260,
            mapScale: 25,
            mapName: 'Map 3',
            mapId: 'map3',
            mapUrl: 'map_1.svg',
            floor: 3,
            POIs: getPoints(),
            routeData: {
                nodes: getNodes(),
                edges: getEdges(),
                nearestExit: {
                    id: 'room-6_1_',
                    title: 'elevator',
                    description: 'the elevator',
                    location: {
                        shapeType: 'polygon',
                        positions: [
                            [0, 118],
                            [174, 118],
                            [174, 222],
                            [0, 222],
                        ],
                    },
                },
            },
        },
        {
            mapWidth: 810,
            mapHeight: 1260,
            mapScale: 25,
            mapName: 'Map 4',
            mapId: 'map4',
            mapUrl: 'map_with_route.svg',
            floor: 4,
            POIs: getPoints(),
            routeData: {
                nodes: getNodes(),
                edges: getEdges(),
                nearestExit: {
                    id: 'room-6_1_',
                    title: 'elevator',
                    description: 'the elevator',
                    location: {
                        shapeType: 'polygon',
                        positions: [
                            [0, 118],
                            [174, 118],
                            [174, 222],
                            [0, 222],
                        ],
                    },
                },
            },
        },
    ],
    themes: {
        '--wf-background': '#0D325F',
        '--wf-panel-background': '#154071',
        '--wf-main-color': '#3C4F62',
        '--wf-text-color': '#FFFFFF',
        '--wf-active-color': '#00C1AD',
        '--wf-font-family': 'Klavika',
        '--wf-font-size': '10px',
        '--wf-font-weight': 'normal',
        '--wf-font-style': 'normal',
    },
    currentPoint: {
        id: 'room-7_1_',
        title: 'terminal 1',
        description: 'You are near terminal 1',
        location: {
            positions: [[748, 374]],
            floor: 1,
            size: {
                width: 100,
                height: 100,
            },
        },
    },
};

ReactDOM.render(React__default.createElement("div", { style: { width: "100%", height: "100%", margin: "0" } },
    React__default.createElement(WayFinding, { mapData: data.maps, themeData: data.themes, currentPoint: data.currentPoint })), document.getElementById('root'));

export default WayFinding;
//# sourceMappingURL=index.es.js.map
