import { POI } from './way-finding/models/POI';
export declare enum poiType {
    Room = "room",
    Terminal = "terminal",
    WC = "wc",
    Exit = "exit",
    Store = "store",
    Exchange = "exchange",
    Food = "food",
    Parking = "parking"
}
export declare const data: {
    maps: {
        mapWidth: number;
        mapHeight: number;
        mapName: string;
        mapId: string;
        mapUrl: string;
        mapScale: number;
        floor: number;
        POIs: POI[];
        routeData: {
            nodes: {
                id: string;
                coords: [number, number];
            }[];
            edges: {
                node1: [number, number];
                node2: [number, number];
            }[];
            nearestExit: {
                id: string;
                title: string;
                description: string;
                location: {
                    shapeType: string;
                    positions: number[][];
                };
            };
        };
    }[];
    themes: {
        '--wf-background': string;
        '--wf-panel-background': string;
        '--wf-main-color': string;
        '--wf-text-color': string;
        '--wf-active-color': string;
        '--wf-font-family': string;
        '--wf-font-size': string;
        '--wf-font-weight': string;
        '--wf-font-style': string;
    };
    currentPoint: {
        id: string;
        title: string;
        description: string;
        location: {
            positions: number[][];
            floor: number;
            size: {
                width: number;
                height: number;
            };
        };
    };
};
