import { IRouteStore } from './RouteStore';
import { IPoi } from './POI';
import { IMap } from './WFMap';
export interface ILevels {
    nameLevel: number;
    totalAmountTypes: {}[];
}
export interface ISearchInformation {
    categories: string[];
    floor: number;
    id: string;
    title: string;
}
export interface IMapStore {
    activeLevel: number;
    activeMap: IMap;
    activePoiId: string;
    activeType: string;
    isOpenSearchPanel: boolean;
    currentPoint: IPoi;
    levels: ILevels[];
    maps: IMap[];
    searchButtons: string[];
    searchInformation: ISearchInformation[];
    zoomStep: number;
    maxZoom: number;
    minZoom: number;
    routeStore: IRouteStore;
    openSearchPanel(): void;
    setActiveLevel(level: number): void;
    setActivePoiId(id: any, level?: any): void;
    setActiveType(type: any): void;
    initMapData(maps: any, currentPoint: any): void;
}
export declare class MapStore implements IMapStore {
    activeLevel: any;
    activeMap: any;
    activePoiId: string;
    activeType: string;
    currentPoint: any;
    maps: any;
    isOpenSearchPanel: boolean;
    routeStore: any;
    zoomStep: number;
    maxZoom: number;
    minZoom: number;
    searchButtons: string[];
    get levels(): ILevels[];
    get searchInformation(): ISearchInformation[];
    setActiveLevel(level: number): void;
    openSearchPanel(): void;
    setActivePoiId(id: any, level?: any): void;
    setActiveType(type: any): void;
    createMaps(mapData: any): IMap[];
    initMapData(mapData: any, currentPoint: any): void;
}
