import { MapStore } from './MapStore';
import { IGraph } from './Graph';
import { IPoi } from './POI';
interface IRoutePath {
    positions: [] | [][];
    distance: number;
}
interface IShortestPath {
    path: string[];
    distance: number;
}
interface IPath {
    floor: number;
    startPoint: string;
    finishPoint: string;
    path: {
        path: string[];
        distance: number;
    };
}
export interface IRouteStore {
    graphs: IGraph[];
    mapStore: MapStore;
    paths: {
        currentFloor: IPath;
        finishFloor: IPath | null;
    };
    pathDetails: {
        startPoint: {};
        exit: {};
        finishPoint: {
            title: string;
            type: string;
            floor: number;
        };
    };
    routePath: IRoutePath;
    resetPaths(): void;
    getShortestPath(graph: IGraph, startPoint: string, finishPoint: string): IShortestPath;
    setFinishPoint(poi: IPoi): void;
}
export declare class RouteStore implements IRouteStore {
    graphs: never[];
    mapStore: any;
    paths: any;
    pathDetails: any;
    get routePath(): IRoutePath;
    constructor(mapStore: MapStore);
    initGraphs(): void;
    initPaths(): void;
    setFinishPoint(poi: IPoi): void;
    setPaths(): void;
    setPathDetails(poi: IPoi): void;
    getShortestPath(graph: IGraph, startPoint: string, finishPoint: string): IShortestPath;
    resetPaths(): void;
}
export {};
